
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何使用ajax开发web应用程序 / iVAN</title>

    <meta name="description" content="如何使用ajax开发web应用程序 ajax|web|程序 作者: Jonathan Fenocchi时间:2005.10.25译者:Sheneyan英文原文:http://webreference.com/programming/javascript/jf/column12/index.html 在过去,由于为了获得新数据而不得不重新加载web页面(或者加载其他页面)导致web应用程序发展被限制.虽然有其他方法可用(不加载其他页面),但是这些技术都没有被很好地支持而且有bug成灾的趋向.在过去的几个月里,一个过去并不被广泛支持的">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">如何使用ajax开发web应用程序</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>ajax|web|程序</p>
<p><strong>作者：</strong> Jonathan Fenocchi<br /><strong>时间：</strong>2005.10.25<br /><strong>译者：</strong>Sheneyan<br /><strong>英文原文：<br /></strong><u>http://webreference.com/programming/javascript/jf/column12/index.html</u></p>
<table>
<tr>
<td></td>
</tr>
</table>
<p>在过去，由于为了获得新数据而不得不重新加载web页面（或者加载其他页面）导致web应用程序发展被限制。虽然有其他方法可用（不加载其他页面），但是这些技术都没有被很好地支持而且有bug成灾的趋向。在过去的几个月里，一个过去并不被广泛支持的技术已经被越来越多的web冲浪者（web surfers??是指浏览器还是浏览者？）所接受，它给了开发者更多的自由开发先进的web应用程序。这些通过javascript来异步取得xml数据的应用程序，被亲切的称为“Ajax应用程序”（Asynchronous Javascript and XML applications）。在这篇文章中，我将会解释如何通过Ajax来取回一个远程的XML文件并更新一个web page，并且随着这个系列的继续，我将讨论更多的方法，使用ajax技术将你的web应用程序提升到一个新的层次.</p>
<p>这第一步就是创建一个带一些数据的XML文件。我们将这个文件命名为data.xml。它是一个简单的XML文件，而在一个真实的程序中，它会复杂许多，但对于我们的例子来说，简单明了是最合适地。</p>
<p>&lt;?xml version="1.0" encoding="UTF-8"?&gt; &lt;root&gt; &lt;data&gt; 这是一些示例数据，它被保存在一个XML文件中，并被JavaScript取回。 &lt;/data&gt; &lt;/root&gt;</p>
<p>现在让我们创建一个简单的web页面包含一些示例数据。这个页面将是我们的js脚本所在，并且这个页面将会让用户们访问柄看到Ajax脚本的运行。我们把它命名为ajax.html</p>
<p>&lt;!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN"<br />  "http://www.w3.org/TR/html4/strict.dtd"&gt;<br />&lt;html lang="zh" dir="ltr"&gt;<br />  &lt;head&gt;<br />    &lt;meta http-equiv="Content-Type" content="text/html; charset=gb2312"&gt;<br />    &lt;title&gt;使用ajax开发web应用程序 - 示例&lt;/title&gt;<br />  &lt;/head&gt;<br />  &lt;body&gt;<br />    &lt;h1&gt;使用ajax开发web应用程序&lt;/h1&gt;<br />    &lt;p&gt;这个页面演示了AJAX技术如何通过动态读取一个远程文件来更新一个网页的内容－－不需要任何网页的重新加载。注意：这个例子对于禁止js的用户来说没有效果。&lt;/p&gt;<br />    &lt;p id="xmlObj"&gt;<br />    这是一些示例数据，它是这个网页的默认数据 &lt;a href="data.xml"<br />    title="查看这个XML数据." &gt;查看XML数据.&lt;/a&gt;<br />    &lt;/p&gt;<br />  &lt;/body&gt;<br />&lt;/html&gt;</p>
<p>注意，对于那些没有javascript的用户，我们直接链接到data.xml文件。对于那些允许运行javascript的用户，函数“ajaxRead”将被运行，这个链接被隐藏，并不会被转向到那个data.xml文件。函数“ajaxRead”现在还没定义。所以如果你要检验上面的示例代码，你会得到一个javascript错误。让我们继续并定义这个函数（还有其他的），让你能够看到ajax是如何工作的，下面的脚本要放到你的head标签里：</p>
<p>&lt;script type="text/javascript"&gt;&lt;!--<br />function ajaxRead(file){<br />  var xmlObj = null;<br />  if(window.XMLHttpRequest){<br />      xmlObj = new XMLHttpRequest();<br />  } else if(window.ActiveXObject){<br />      xmlObj = new ActiveXObject("Microsoft.XMLHTTP");<br />  } else {<br />      return;<br />  }<br />  xmlObj.onreadystatechange = function(){<br />    if(xmlObj.readyState == 4){<br />       updateObj('xmlObj', xmlObj.responseXML.getElementsByTagName('data')[0].firstChild.data);<br />     }<br />    }<br />    xmlObj.open ('GET', file, true);<br />    xmlObj.send ('');<br />  }<br />  function updateObj(obj, data){<br />   document.getElementById(obj).firstChild.data = data;<br />  }<br />  //--&gt;&lt;/script&gt;</p>
<p>（Sheneyan注：完整代码示例见 <u>example.html</u> ML文件见：<u>data.xml</u> ）</p>
<p>这堆代码有点多，让我们一点点的进行。第一个函数叫做“ajaxRead”－也就是我们在页面的“查看XML数据”链接中调用的函数，我们定义了一个“xmlObj”变量－这将作为客户端（用户正在查看的这个web页面）以及服务端（web站点本身）之间的中间件。我们在一个if/else块中定义这个对象：</p>
<p>if(window.XMLHttpRequest){<br />   xmlObj = new XMLHttpRequest();<br />} else if(window.ActiveXObject){<br />   xmlObj = new ActiveXObject("Microsoft.XMLHTTP");<br />} else {<br />   return;<br />}</p>
<p>这只是一个对不同对象是否可用的测试－某些浏览器实现了不同的XMLHttpRequest对象，所以当我们定义“xmlObj”作为我们的XMLHttpRequest对象时，我们不得不根据浏览器所实现的来定义它。如果没有可用的XMLHttpRequest对象，我们将执行“return”语句结束这个函数以避免脚本错误。在大部分情况下，这个检验将返回一个XMLHttpRequest对象－这部分代码应该能够在绝大部分的浏览器上工作，除了少部分比较老的浏览器的异常情况（它能够工作在ie5.01上，但是在netscape4上会使函数终止）。</p>
<p>接下来是这些代码块:</p>
<p>xmlObj.onreadystatechange = function(){<br />  if(xmlObj.readyState == 4){<br />      updateObj('xmlObj', xmlObj.responseXML.getElementsByTagName('data')[0].firstChild.data);<br />  }<br />}</p>
<p>每次XMLHttpRequest的状态发生变化，事件“onreadystatechange”就会被触发。通过使用“xmlObj.onreadystatechange = function(){...}”我们能够创建一个函数并让它在这个XMLHttpRequest对象的状态每次发生改变的时候立刻运行。这里总共有五个状态，由0走到4。</p>
<p><b>0</b> – 尚未初始化（在这个XMLHttpRequest开始前）</p>
<p><b>1</b> – 加载（XMLHttpRequest初始化一结束）</p>
<p><b>2</b> – 加载结束（XMLHttpRequest一从服务器上获得一个回应）</p>
<p><b>3</b> – 交互（当XMLHttpRequest对象和服务器连接中）</p>
<p><b>4</b> – 结束（当XMLHttpRequest被告知它已经完成了所有人物并结束运行）</p>
<p>这第五个状态（数字4）就是我们能够确定数据已经可用的标志，所以我们检验这个xmlObj.readyState是否等于“4”来确定数据是否可用，如果是4，我们运行updateObj函数。这个函数带两个参数：一个当前web页面的元素ID（当前web页面中要更新的元素）以及用于填充这个元素的数据。这个函数的运行方式在稍后将更详细地解释。</p>
<p>我们的web页面的p元素有一个id“xmlData”，这就是我们准备更新的段落。我们正在取得的数据来自于XML文件，但它有点复杂。这里是它如何工作的原理。</p>
<p>xmlObj.responseXML属性是一个DOM对象 － 它很象“document”对象，除了它来自远程的XML文件。换句话说，如果你在data.xml中运行脚本，那xmlObj.responseXML就是一个“document”对象。因为我们知道这些，我们能够通过“getElementsByTagName”方法取得任何XML节点。数据包含在一个命名为“&lt;data&gt;”的XML节点中，所以我们的任务很简单：取得第一个（而且只有这一个）数据节点。因而，xmlObject.responseXML.getElementsByTagName("data")[0]返回XML文件中的第一个&lt;data&gt;节点。<br /><b>注意：</b>它返回的是XML节点，而不是节点中的数据－这个数据必须通过访问XML节点的属性取得，这就是下一步要说的。</p>
<p>接下来，取得数据只需要简单的指定“firstChild.data”（firstChild指向了那个被&lt;data&gt;节点包含的文本节点，而这个“data”属性则是这个文本节点的实际文本）。</p>
<p>xmlObj.open ('GET', file, true);<br />xmlObj.send ('');</p>
<p>这是我们的ajaxRead函数的最后一个部分。它说了些什么？嗯，xmlObj的这个“open”方法打开了一个到服务器（通过一个指定的协议，这里指定的是“GET”－你可以使用“USE”或者其他别的协议）的连接，去请求一个文件（在我们的例子里，变量“file”被作为一个参数赋给ajaxRead函数－data.xml），而且javascript可以同步（false）或者异步（true，默认值）的处理请求。由于这是异步的Javascript和XML（AJAX），我们将使用默认的异步方式－在这个例子中，使用同步方式将不起作用。</p>
<p>这是我们函数中的最后一行，它简单的发送一个空字符串回服务器。如果没有这行，xmlObj的readyState永远不会到4，所以你的页面永远不会更新。这个send方法能够用于作其他事情，但今天我只是用来从服务器上取得数据－并不发送它－所以在这篇文章中我不准备介入任何关于send方法的细节。</p>
<p>function updateObj(obj, data){<br />  document.getElementById(obj).firstChild.data = data;<br />}</p>
<p>现在再稍微解释一下updateObj函数：这个函数使用一个新的值来更新当前页面上任何指定的元素。他的第一个参数，“obj”是当前页面中元素的ID－那个要被更新的对象；它的第二个参数，“data”是用来将那个将被替换值的对象（“obj”）的内容替换掉。一般来说，检验一下并确定当前页面上确实有一个元素的ID是“obj”是比较明智的，但对我们的脚本的这个隔离级别来说校验并不必要。这个函数更新的方式和我们之前从XML文件的“data”节点取得数据的方式类似－它定位它要更新的元素（这时候这个元素的ID代替了它的标签名和在页面中的索引）并设置这个元素的第一个子节点（文本节点）的data属性为新的值。如果你需要使用HTML而不是纯文本来更新一个元素，你也可以使用</p>
<p>document.getElementById(obj).innerHTML = data</p>
<p><b>这就是全部了</b></p>
<p>这个概念很简单，而且代码也不是很难。你能够从某个地方读取一个文件并且不需要重新加载这个web页面。你有足够的灵活性来作各种事情，包括从表单发送数据（不需要重新加载web页面）并且使用一个服务端语言来动态生成XML文件。如果你需要更近一步，记得这个<u>连接</u>是很有用的－哦，还要记得Google是你朋友。在另外的文章中，我将解释你如何配合服务端技术使用AJAX来构造强大的web应用程序。</p>
<p>在上一篇文章中，我们讨论了如何通过javascript从一个远程XML文件中取得数据。在这篇文章中，我们将学会怎样对数据作更复杂的处理。作为一个示例，我们会准备一组XML数据，将数据分割成独立的片断并以不同的方式展示这些片断（取决于它们是如何被标识的）。</p>
<p>这篇文章是建立在上一篇文章中构造的示例代码的基础之上，所以如果你不能理解我们现在的代码，你可以回过头去读第一篇文章（sheneyan注：就在上面）。</p>
<p><strong>开始～</strong></p>
<p>让我们开始我们的第一步：构造XML。我们准备写一个XML文档，它组织了一系列准备让javascript处理的数据，所以我们将一起组织一些节点和子节点（或者，元素和子元素）。在这个例子里，我们将使用一些家庭宠物的名字：</p>
<p>&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />&lt;data&gt;<br />  &lt;pets&gt;<br />   &lt;pet&gt;猫&lt;/pet&gt;<br />   &lt;pet&gt;狗&lt;/pet&gt;<br />   &lt;pet&gt;鱼&lt;/pet&gt;<br />  &lt;/pets&gt;<br />&lt;/data&gt;</p>
<p>在上面，我们有这个XML声明（标明这个文档是一个XML 1.0 文档，使用UTF-8编码），一个根元素（&lt;data&gt;）将下面所有的元素组合在一起，一个&lt;pets&gt;元素组织了所有的宠物，然后一个&lt;pet&gt;节点对应一只宠物。为了指定每一只宠物是什么类型的动物，我们在&lt;pet&gt;元素中设置了文本节点：猫，狗，鱼。</p>
<p>&lt;!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN"<br />  "http://www.w3.org/TR/html4/strict.dtd"&gt;<br />&lt;html lang="zh" dir="ltr"&gt;<br />  &lt;head&gt;<br />    &lt;meta http-equiv="Content-Type" content="text/html; charset=gb2312"&gt;<br />    &lt;title&gt;使用Ajax开发Web应用程序 - 示例&lt;/title&gt;<br />    &lt;script type="text/javascript"&gt;&lt;!--<br />    function ajaxRead(file){<br />      var xmlObj = null;<br />      if(window.XMLHttpRequest){<br />          xmlObj = new XMLHttpRequest();<br />      } else if(window.ActiveXObject){<br />          xmlObj = new ActiveXObject("Microsoft.XMLHTTP");<br />      } else {<br />          return;<br />      }<br />      xmlObj.onreadystatechange = function(){<br />        if(xmlObj.readyState == 4){<br />          processXML(xmlObj.responseXML);<br />        }<br />      }<br />      xmlObj.open ('GET', file, true);<br />      xmlObj.send ('');<br />    }<br />    function processXML(obj){<br />      var dataArray = obj.getElementsByTagName('pet');<br />      var dataArrayLen = dataArray.length;<br />      var insertData = '&lt;table style="width:150px; border: solid 1px #000"&gt;&lt;tr&gt;&lt;th&gt;'<br />        + 'Pets&lt;/th&gt;&lt;/tr&gt;';<br />      for (var i=0; i&lt;dataArrayLen; i++){<br />          insertData += '&lt;tr&gt;&lt;td&gt;' + dataArray[i].firstChild.data + '&lt;/td&gt;&lt;/tr&gt;';<br />      }<br />      insertData += '&lt;/table&gt;';<br />      document.getElementById ('dataArea').innerHTML = insertData;<br />    }<br />    //--&gt;&lt;/script&gt;<br />  &lt;/head&gt;<br />  &lt;body&gt;<br />    &lt;h1&gt;使用Ajax开发web应用程序&lt;/h1&gt;<br />    &lt;p&gt;这个页面演示了AJAX技术如何通过动态读取一个远程文件来更新一个网页的内容－－不需要任何网页的重新加载。注意：这个例子对于禁止js的用户来说没有效果。&lt;/p&gt;<br />    &lt;p&gt;这个页面将演示如从取回并处理成组的XML数据。被取回的数据将会以表格形式输出到底下。<br />&lt;a href="#" &gt;查看演示&lt;/a&gt;.&lt;/p&gt;<br />    &lt;div id="dataArea"&gt;&lt;/div&gt;<br />  &lt;/body&gt;<br />&lt;/html&gt;</p>
<p>（Sheneyan注：完整代码示例见 <u>example_2.html</u> ，XML文件见：<u>data_2.xml</u>）</p>
<p>你会注意到我们和上次一样以同样的方式（通过一个超链接）调用了这个函数，而且我们将数据放入一个DIV（这次这个东东叫做“dataArea”）。这个ajaxRead()函数和上次很接近，除了一点不同：onreadystatechange函数。让我们先看一下这个函数：</p>
<p>xmlObj.onreadystatechange = function(){<br />      if(xmlObj.readyState == 4){<br />          processXML(xmlObj.responseXML);<br />     }<br />}</p>
<p>我们取消了updateObj函数并用一个叫做processXML()的新函数来代替它。这个函数将得到XML文档本身（也就是被ajaxRead函数取回的）并处理它。（这“XML文档本身”我指的是参数“xmlObj.responseXML”）</p>
<p>现在让我们分析一下这个函数processXML。下面是它的代码：</p>
<p>      function processXML(obj){<br />      var dataArray = obj.getElementsByTagName('pet');<br />      var dataArrayLen = dataArray.length;<br />      var insertData = '&lt;table style="width:150px; border: solid 1px #000"&gt;&lt;tr&gt;&lt;th&gt;'<br />      + 'Pets&lt;/th&gt;&lt;/tr&gt;';<br />      for (var i=0; i&lt;dataArrayLen; i++){<br />          insertData += '&lt;tr&gt;&lt;td&gt;' + dataArray[i].firstChild.data + '&lt;/td&gt;&lt;/tr&gt;';<br />     }<br />     insertData += '&lt;/table&gt;';<br />     document.getElementById ('dataArea').innerHTML = insertData;<br />   } </p>
<p>首先，我们定义了一些变量。“dataArray”作为所有&lt;pet&gt;节点的数组（不是节点数据，只是节点）。“dataArrayLen”是这个数组的长度，用于我们的循环。“insertData”则是一个表格的开头的HTML。</p>
<p>我们的第二步则是遍历所有的&lt;pet&gt;元素（通过变量“dataArray”）并将数据添加到变量insertData中。这里我们会创建一个表格行，插入一个表格数据节点(td)进去，再将每一个&lt;pet&gt;元素的文本包含进这个表格数据节点，并将这些都添加进变量“insertData”。因此，每循环一次，变量insertData将添加一行包含三个宠物中之一名称的新数据。</p>
<p>新数据行添加完后，我们插入一个“&lt;/table&gt;”结束标签到变量“insertData”。这完成了这个表格，然后我只剩这最后一步来达成我们的目标：我们需要将这个表格放到页面上。幸运的是，我们得感谢innerHTML属性，这很简单。我们通过函数document.getElementById()取得DIV“dataArea”并将变量“insertData”中的HTML插进去。嗯，这个表格冒出来了！</p>
<p><strong>我们继续之前……</strong></p>
<p><strong>我得指出两点：</strong></p>
<p>首先，你会注意到我们并没有使用节点&lt;pets&gt;。这事因为我们只有一个数据组（&lt;pets&gt;）以及后来所有的元素（每一个&lt;pet&gt;元素）；这些子节点包含了不同的数据但它们有相同的名字。在这个例子中，这个节点能够被忽略。然而，将所有的元素&lt;pet&gt;放进&lt;pets&gt;元素还是比较好，而不是让这些&lt;pet&gt;元素自己散放（但仍然在data元素里面）。</p>
<p>另外一种方式是给每一个宠物放一个指定的标签，比如：</p>
<p> &lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />&lt;data&gt;<br />  &lt;pets&gt;<br />    &lt;猫 /&gt;<br />    &lt;狗 /&gt;<br />    &lt;鱼 /&gt;<br />  &lt;/pets&gt;<br />&lt;/data&gt; </p>
<p>然后我们能够遍历元素&lt;pets&gt;里的节点。这个processXML函数看起来就像这样：</p>
<p>    function processXML(obj){<br />      var dataArray = obj.getElementsByTagName('pets')[0].childNodes;<br />      var dataArrayLen = dataArray.length;<br />      var insertData = '&lt;table style="width:150px; border: solid 1px #000"&gt;&lt;tr&gt;&lt;th&gt;'<br />     + 'Pets&lt;/th&gt;&lt;/tr&gt;';<br />    for (var i=0; i&lt;dataArrayLen; i++){<br />       if(dataArray[i].tagName){<br />          insertData += '&lt;tr&gt;&lt;td&gt;' + dataArray[i].tagName + '&lt;/td&gt;&lt;/tr&gt;';<br />       }<br />    }<br />    insertData += '&lt;/table&gt;';<br />    document.getElementById ('dataArea').innerHTML = insertData;<br />  }</p>
<p>（Sheneyan注：修改后的示例见：<u>example_2_1.html</u> ，XML文件见：<u>data_2_1.xml</u>）</p>
<p>这里所作的修改就是我们指向了&lt;pets&gt;组元素（这个“[0]”意味这是第一个，即使它就是唯一的那一个）以及它的子节点（元素&lt;猫 /&gt;，&lt;狗 /&gt;，&lt;鱼 /&gt;）。因为文本元素分割了这几个元素（空格被认为是一个节点），我们需要确定只有那些有标签名的节点（嗯，也就是只有标签）通过。然后我们输出每一个标签的名字。因为每一个标签名是一个宠物，我们不需要取得每一个节点的数据－节点名本身已经足够。去看一下它是怎么工作的吧。</p>
<p>还有另外一种方式来完成我们上面的工作，就是给每一个&lt;pet&gt;节点设置一个属性值。你的XML文档看起来就像这样：</p>
<p>&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />&lt;data&gt;<br />  &lt;pets&gt;<br />    &lt;pet type="猫" /&gt;<br />    &lt;pet type="狗" /&gt;<br />    &lt;pet type="鱼" /&gt;<br />  &lt;/pets&gt;<br />&lt;/data&gt; </p>
<p>你只需要稍微修改一下你的processXML函数，它变成这样子了：</p>
<p>    function processXML(obj){<br />      var dataArray = obj.getElementsByTagName('pet');<br />      var dataArrayLen = dataArray.length;<br />      var insertData = '&lt;table style="width:150px; border: solid 1px #000"&gt;&lt;tr&gt;&lt;th&gt;'<br />      + 'Pets&lt;/th&gt;&lt;/tr&gt;';<br />    for (var i=0; i&lt;dataArrayLen; i++){<br />          insertData += '&lt;tr&gt;&lt;td&gt;' + dataArray[i].getAttribute('type') + '&lt;/td&gt;&lt;/tr&gt;';<br />      }<br />      insertData += '&lt;/table&gt;';<br />      document.getElementById ('dataArea').innerHTML = insertData;<br />   }</p>
<p>（Sheneyan注：修改后的示例见：<u>example_2_2.html</u><u> </u> ，XML文件见：<u>data_2_2.xml</u>）</p>
<p>关键的不同在于我们通过dataArray[i].getAttribute('type')取得值，它返回了当前&lt;pet&gt;节点的“type”属性的值。</p>
<p><strong>继续...</strong></p>
<p>现在我们已经知道了一些从一个单独的XML数据组中取回数据的有效方法，让我们看看如何从多个组中取回数据。和只是列出一个pets所拥有的内容不同，我们假设我们有一个针对我们宠物的日课表。因为它们都有不同的需要，每一只宠物都得仔细的照顾。面对这种情况，动物的看管员需要一个每日依据。现在来让我们将这些放入一个良好格式的XML：</p>
<p>&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />&lt;data&gt;<br />  &lt;pets&gt;<br />    &lt;pet&gt;Cat<br />      &lt;task&gt;Feed&lt;/task&gt;<br />      &lt;task&gt;Water&lt;/task&gt;<br />      &lt;task&gt;Comb out fleas&lt;/task&gt;<br />    &lt;/pet&gt;<br />    &lt;pet&gt;Dog<br />      &lt;task&gt;Feed&lt;/task&gt;<br />      &lt;task&gt;Water&lt;/task&gt;<br />      &lt;task&gt;Put outside&lt;/task&gt;<br />    &lt;/pet&gt;<br />    &lt;pet&gt;Fish<br />      &lt;task&gt;Feed&lt;/task&gt;<br />      &lt;task&gt;Check oxygen, water purity, etc.&lt;/task&gt;<br />    &lt;/pet&gt;<br />  &lt;/pets&gt;<br />&lt;/data&gt;</p>
<p>也许这个看起来很奇怪，但这就是我们正在创建的子组(sub-group)。每一个&lt;pet&gt;元素都是一个组&lt;pets&gt;的子组，而每一个&lt;task&gt;则是每一个&lt;pet&gt;组的子元素。</p>
<p>在我继续之前，你也许希望将你的表格用一些css美化一下，比如：</p>
<p>  &lt;style type="text/css"&gt;&lt;!--<br />  table, tr, th, td {<br />    border: solid 1px #000;<br />    border-collapse: collapse;<br />    padding: 5px;<br /> }<br />--&gt;&lt;/style&gt;</p>
<p>这让这个表格更容易读取。现在让我们去研究函数processXML：</p>
<p>  function processXML(obj){<br />    var dataArray = obj.getElementsByTagName('pet');<br />    var dataArrayLen = dataArray.length;<br />    var subAry, subAryLen;<br />    var insertData = '&lt;table&gt;&lt;tr&gt;&lt;th&gt;'<br />      + 'Pets&lt;/th&gt;&lt;th&gt;Tasks&lt;/th&gt;&lt;/tr&gt;';<br />    for (var i=0; i&lt;dataArrayLen; i++){<br />          insertData += '&lt;tr&gt;&lt;td&gt;' + dataArray[i].firstChild.data + '&lt;/td&gt;';<br />          subAry = dataArray[i].getElementsByTagName('task');<br />          subAryLen = subAry.length;<br />          insertData += '&lt;td&gt;';<br />            for(var j=0; j&lt;subAryLen; j++){<br />              insertData += subAry[j].firstChild.data;<br />              if( subAryLen != j+1 ) { insertData += ', '; }<br />            }<br />        insertData += '&lt;/td&gt;&lt;/tr&gt;';<br />  }<br />  insertData += '&lt;/table&gt;';<br />  document.getElementById ('dataArea').innerHTML = insertData;<br />}</p>
<p>（Sheneyan注：修改后的示例见：<u>example_2_3.html</u> ，XML文件见：<u>data_2_3.xml</u>）</p>
<p>新增加的内容，首先是两个新变量的声明：“subAry”和“subAryLen”。它们和之前的变量“dataArray”和“dataArrayLen”类似，除了它们指向不同的数组（特别是它们将指向那些“task”元素－当“dataArray”和“dataArrayLen”指向“pet”元素的时候）。</p>
<p>我们也改变了变量“insertData”的初始值－我们增加了一个表格头（&lt;th&gt;）给我们的“tasks”字段。</p>
<p>下一步改变在于循环：我们把值赋给subAry和subAryLen变量。变量subAry成为当前&lt;pet&gt;的&lt;task&gt;元素的数组。变量subAryLen成为这个数组的长度，直到这个数组发生变化（当外部循环走到下一个&lt;pet&gt;时）。</p>
<p>我们创建了一个内嵌的循环来处理所有的&lt;task&gt;元素，一次一个。大概来说，我们创建一个新的数据格，放进一个用逗号分隔的任务列表，然后关闭数据表格以及当前行。尤其，这些&lt;task&gt;元素节点数据（任务本身，比如，“喂食”）放置入变量“insertData”里的数据格。</p>
<p>接下来，我们检验当前&lt;pet&gt;是否有其它更多的task。如果还有，我们增加一个逗号（，）到变量insertData来让每一个任务使用一个逗号分隔（“a, b, c”，而不是“a, b, c,”－注意，最后一个逗号在第二个任务那里，所以我们不需要）。这个工作在我们取得subAry数组长度的时候（给循环的“j”变量加1）就完成了。因为这个循环会在下一个循环的时候把变量“j”递增1,“j”会比它这次检验时还多1。因此，如果“j+1”（或者，“当循环再次开始的时候j的值”）等于subAryLen（当前&lt;pet&gt;节点的&lt;task&gt;节点数目），这个循环将停止。如果循环不再运行，我们就不再添加新的逗号来分隔任务。所以如果“j+1”不等于subAryLen，我们直到我们可以安全的加入逗号到“insertData”，为下一个&lt;task&gt;作准备。</p>
<p>一旦内循环结束，我们关闭task数据格以及pet行。外部循环会重新开始创建一个新行以及移动到下一个&lt;pet&gt;。这个处理一直进行到所有的&lt;pet&gt;元素（以及每一个pet的所有&lt;task&gt;元素）都被处理完。</p>
<p><strong>有其他方法吗？</strong></p>
<p>你也许会想：“那javascript变得相当复杂了，但它只会随着XML越来越复杂而跟着变复杂，也许我们能够简化XML，然后，简化javascript”。如果你这么想，很棒，因为你完全正确。我之前展示的不同方法之一，我详细说明的那个也许能够成为最合适的。我们怎么使用属性来对应每一只宠物以及相应任务？XML看起来会变成怎样？</p>
<p>&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />&lt;data&gt;<br />  &lt;pets&gt;<br />    &lt;pet type="Cat" tasks="Feed, Water, Comb out fleas" /&gt;<br />    &lt;pet type="Dog" tasks="Feed, Water, Put outside" /&gt;<br />    &lt;pet type="Fish" tasks="Feed, Check oxygen, water purity, etc." /&gt;<br />  &lt;/pets&gt;<br />&lt;/data&gt; </p>
<p>哇哦！看起来简单多了。让我们看看我们的processXML函数如何修改：</p>
<p>  function processXML(obj){<br />    var dataArray = obj.getElementsByTagName('pet');<br />    var dataArrayLen = dataArray.length;<br />    var insertData = '&lt;table&gt;&lt;tr&gt;&lt;th&gt;'<br />     + 'Pets&lt;/th&gt;&lt;th&gt;Tasks&lt;/th&gt;&lt;/tr&gt;';<br />    for (var i=0; i&lt;dataArrayLen; i++){<br />        insertData += '&lt;tr&gt;&lt;td&gt;' + dataArray[i].getAttribute('type')             + '&lt;/td&gt;'<br />+ '&lt;td&gt;' + dataArray[i].getAttribute('tasks') + '&lt;/td&gt;&lt;/tr&gt;';<br />    }<br />    insertData += '&lt;/table&gt;';<br />    document.getElementById ('dataArea').innerHTML = insertData;<br />}</p>
<p>（Sheneyan注：修改后的示例见：<u>example_2_4.html</u>，XML文件见：<u>data_2_4.xml</u>）</p>
<p>就像你猜的一样，函数简单多了。因为代码变得简单，它也会变得更有效率。和我们比较老的函数的唯一的不同在于这个变量insertData现在插入更多的HTML，尤其是两个新变量“type”和“tasks”。就如我们较早之前所学的，那些属性是我们从XML文档的&lt;pet&gt;元素中取得的，而且每个pet的属性都有不同的值。对于你自己修改这个XML文件以适应你的进度的变动来说也许是最简单的方法。例如，如果你最终把你的猫身上的跳蚤抓光了，你只要简单从你的猫的每日任务表中把“减少跳蚤数量”删除，然而在之前我们使用的XML中，实现起来也许会觉得糊里糊涂。</p>
<p>最后的XML格式化的方法是将两部分混合。现在，我们将使用属性和不同的标签。让我们看一下示例XML：</p>
<p>&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />&lt;data&gt;<br />  &lt;pets&gt;<br />    &lt;猫 tasks="喂食, 饮水, 减少跳蚤数量" /&gt;<br />    &lt;狗 tasks="喂食, 饮水, 带出去遛遛" /&gt;<br />    &lt;鱼 tasks="喂食, 检查氧气，水的纯度，其它" /&gt;<br />  &lt;/pets&gt;<br />&lt;/data&gt; </p>
<p>这也许是最便于理解的XML。让我们分析一下我们为了让processXML函数运作起来所作的变更：</p>
<p>function processXML(obj){<br />    var dataArray = obj.getElementsByTagName('pets')[0].childNodes;<br />    var dataArrayLen = dataArray.length;<br />    var insertData = '&lt;table&gt;&lt;tr&gt;&lt;th&gt;'<br />     + 'Pets&lt;/th&gt;&lt;th&gt;Tasks&lt;/th&gt;&lt;/tr&gt;';<br />    for (var i=0; i&lt;dataArrayLen; i++){<br />      if(dataArray[i].tagName){<br />        insertData += '&lt;tr&gt;&lt;td&gt;' + dataArray[i].tagName + '&lt;/td&gt;'<br />            + '&lt;td&gt;' + dataArray[i].getAttribute('tasks') + '&lt;/td&gt;&lt;/tr&gt;';<br />      }<br />  }<br />  insertData += '&lt;/table&gt;';<br />  document.getElementById ('dataArea').innerHTML = insertData;<br />}</p>
<p>（Sheneyan注：修改后的示例见：<u>example_2_5.html</u>，XML文件见：<u>data_2_5.xml</u>）</p>
<p>“dataArray”现在指向了&lt;pets&gt;的子节点，将它们作为一个数组对待（换句话说，dataArray现在是在&lt;pets&gt;节点内所有节点的数组）。这事因为每一个标签都不同（&lt;猫 /&gt;，&lt;狗 /&gt;，&lt;鱼 /&gt;），所以我们不能使用这些元素的名称来搜索它们（而之前我们可以使用&lt;pet&gt;，因为所有的元素都是&lt;pet&gt;）。</p>
<p>还是一样，每个节点之间的有空格，所以在我们的处理过程中得排除掉文本节点。我们能够检验标签名是否存在－文本节点是节点但没有标签，而&lt;猫 /&gt;，&lt;狗 /&gt;，&lt;鱼 /&gt;节点都是标签。所以如果一个标签有名字，那我们能够将数据插入变量insertData。我们插入的数据是一个表格并有两个表格数据格。这第一个单元格是标签名，也就是宠物的类型（猫，狗或鱼），而第二个单元格则是指定动物的“tasks”属性值（比如“喂食或饮水”）。</p>
<p><strong>结束语</strong></p>
<p>在这篇文章里，我演示了这个例子的很多变化，你可以随意试验它们来检验哪个更适合你。只要记住一点，XML是“可扩展的”，所以没有“错误的”方法来组合你的数据，虽然经常有一个“最好的”方法。而且，要注意让你的XML保持格式良好。记住很多问题来自于忘记结束一个标签（比如&lt;狗 /&gt;而不是&lt;狗&gt;;除非这个节点中有数据，比如下面的&lt;狗&gt;这里有数据哦&lt;/狗&gt;）。</p>
<p>我意图使XML和javascript的应用不糊涂而变得明朗。一步步的学习处理更多的数据，你能够将ajax运用于更大的用途。我希望看到ajax更多的应用于企业网站，及其它。所以如果你将这些知识应用于实践，我很高兴了解到你学到了什么（mail：jona#slightlyremarkable.com #换成@）。</p>
<p>在这个关于AJAX系列的第三部分中，我们将学习如何使用AJAX与服务端进行写作以及这些技术如何产生强大的web应用程序。如果你对学习如何构建类似GMail或者Google Maps的web程序感兴趣的话，这是一篇基础的入门（虽然那两个东东会比我们在这篇文章中提及的内容复杂的多）。在这篇文章中，我使用PHP作为服务端语言，但AJAX能够和任何服务端语言进行很好的兼容，所以你尽可以选择你所钟爱的任何语言！</p>
<p>我们还是从我们上一篇文章的代码（喏，就在上面）开始我们的学习，你可以去阅读它来作为参考。</p>
<p>这里就是这个HTML页面（带js）：</p>
<p>&lt;!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN"<br /> "http://www.w3.org/TR/html4/strict.dtd"&gt;<br />&lt;html lang="zh-cn" dir="ltr"&gt;<br /> &lt;head&gt;<br />  &lt;meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"&gt;<br />  &lt;title&gt;如何使用ajax开发web应用程序--示例&lt;/title&gt;<br />  &lt;script type="text/javascript"&gt;&lt;!--<br />  function ajaxRead(file){<br />   var xmlObj = null;<br />   if(window.XMLHttpRequest){<br />      xmlObj = new XMLHttpRequest();<br />   } else if(window.ActiveXObject){<br />      xmlObj = new ActiveXObject("Microsoft.XMLHTTP");<br />   } else {<br />      return;<br />   }<br />   xmlObj.onreadystatechange = function(){<br />    if(xmlObj.readyState == 4){<br />       processXML(xmlObj.responseXML);<br />    }<br />   }<br />   xmlObj.open ('GET', file, true);<br />   xmlObj.send ('');<br />  }<br />  function processXML(obj){<br />   var dataArray = obj.getElementsByTagName('pets')[0].childNodes;<br />   var dataArrayLen = dataArray.length;<br />   var insertData = '&lt;table&gt;&lt;tr&gt;&lt;th&gt;'<br />    + 'Pets&lt;/th&gt;&lt;th&gt;Tasks&lt;/th&gt;&lt;/tr&gt;';<br />   for (var i=0; i&lt;dataArrayLen; i++){<br />     if(dataArray[i].tagName){<br />        insertData += '&lt;tr&gt;&lt;td&gt;' + dataArray[i].tagName + '&lt;/td&gt;'<br />                   +  '&lt;td&gt;' + dataArray[i].getAttribute('tasks') + '&lt;/td&gt;&lt;/tr&gt;';<br />     }<br />   }<br />   insertData += '&lt;/table&gt;';<br />   document.getElementById ('dataArea').innerHTML = insertData;<br />  }<br />  //--&gt;&lt;/script&gt;<br />  &lt;style type="text/css"&gt;&lt;!--<br />  table, tr, th, td {<br />   border: solid 1px #000;<br />   border-collapse: collapse;<br />   padding: 5px;<br />  }<br />  --&gt;&lt;/style&gt;<br /> &lt;/head&gt;<br /> &lt;body&gt;<br />  &lt;h1&gt;使用Ajax开发web应用程序&lt;/h1&gt;<br />  &lt;p&gt;这个页面演示了AJAX技术如何通过动态读取一个远程文件来更新一个网页的内容－－不需要任何网页的重新加载。注意：这个例子对于禁止js的用户来说没有效果。&lt;/p&gt;<br />  &lt;p&gt;这个页面将演示如从取回并处理成组的XML数据。被取回的数据将会以表格形式输出到底下。<br />  &lt;a href="#" &gt;查看演示&lt;/a&gt;.&lt;/p&gt;<br />  &lt;div id="dataArea"&gt;&lt;/div&gt;<br /> &lt;/body&gt;<br />&lt;/html&gt;</p>
<p>(sheneyan注：示例见 <u>example_3.html</u> )<br />　　注意：这里唯一的变化就是我们将我们的ajaxRead()中的“data_2.xml”改成了“data_3.php”。这是因为我们将使用php来输出XML（如果你在你的浏览器里打开这个PHP文件，它会以一个XML文件的形式展现出来－－我们只是要在这个文件中进行操作而不只是一个简单的XML）。这个PHP文件的输出类似：</p>
<p>&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />&lt;data&gt;<br />  &lt;pets&gt;<br />    &lt;猫 tasks="喂食, 饮水, 抓跳蚤" /&gt;<br />    &lt;狗 tasks="喂食, 饮水, 带出去遛遛" /&gt;<br />    &lt;鱼 tasks="喂食, 检查氧气，水的纯度，其它" /&gt;<br />  &lt;/pets&gt;<br />&lt;/data&gt; </p>
<p>(Sheneyan注：示例就不提供了，参考底下说明即可。)</p>
<p>这只是输出结果，我们准备从一个mysql数据库中获取这些信息。从现在起，我们可以直接在我们的数据库中修改数据而不是手动修改XML文件。用AJAX通过PHP来取得数据，并将它获取到一个页面上－－所有这些，仍然不需要重新加载网页。</p>
<p>第一步是连接到mysql去获取数据。这篇文章的重点在javascript，所以我不会解释下面的代码如何工作，你需要自己去了解如何连接mysql数据库。</p>
<p>&lt;?php<br /> $user = "admin";<br /> $pass = "adminpass";<br /> $host = "localhost";<br /> $conn = mysql_connect($host, $user, $pass) or die("Unable to connect to MySQL.");<br /> $db   = mysql_select_db("pets",$conn) or die("Could not select the database.");<br /> mysql_close($db);<br />?&gt;</p>
<p>只要你连接了数据库，你可以通过底下的查询来获取信息：</p>
<p>&lt;?php<br /> $user = "admin";<br /> $pass = "adminpass";<br /> $host = "localhost";<br /> $conn = mysql_connect($host, $user, $pass) or die("Unable to connect to MySQL.");<br /> $db   = mysql_select_db("pets",$conn) or die("Could not select the database.");<br /> $result = mysql_query("SELECT * FROM `pets`");<br />  if(mysql_num_rows ($result) == 0){<br />     die ('Error: no data found in the database.');<br />  }<br />  while ($row = mysql_fetch_assoc($result)){<br />     echo 'Pet: '.$row['pet'].', tasks: '.$row['tasks'].'. ';<br />  }<br /> <br /> mysql_close($db);<br />?&gt;</p>
<p>这段代码给了你需要的信息，但它输出并不正确。我们需要修改这PHP代码来分隔数据为XML，而不是纯文本。为了实现这个目标我们得作几个修改。</p>
<p>&lt;?php<br /> header('Content-Type: text/xml');//编号1<br /> echo '&lt;?xml version="1.0" encoding="UTF-8"?&gt;';//编号2<br /> echo "\n&lt;data&gt;\n&lt;pets&gt;\n";//编号3<br /> $user = "admin";<br /> $pass = "adminpass";<br /> $host = "localhost";<br /> $conn = mysql_connect($host, $user, $pass) or die("无法连接mysql.");<br /> $db   = mysql_select_db("pets",$conn) or die("无法选择数据库.");<br /> $result = mysql_query("SELECT * FROM `pets`");<br />  if(mysql_num_rows ($result) == 0){<br />     die ('Error: 数据库没有数据.');<br />  }<br />  while ($row = mysql_fetch_assoc($result)){<br />     echo '&lt;'.$row['pet'].' tasks="'.$row['tasks'].'" /&gt;'."\n";//编号4<br />  }<br />  echo "&lt;/pets&gt;\n&lt;/data&gt;";//编号5<br /> mysql_close($db);<br />?&gt;</p>
<p>让我们从上面开始，一次一行的来分析它是如何输出XML的.我给每一行都加了注释标记以便于更好的对应理解(原文是I've color-coded each line to make it easier to understand,我懒得上色,就改成用编号了)</p>
<p>编号1:这部分代码发送一个http头来让用户客户端明白这个php文件输出的是一个XML。这就是为什么你在你的浏览器里看这个文档的时候它以一个XML文件的形式展现，即使你的文件有一个“.php”后缀。</p>
<p>编号2:这部分的代码输出了XML声明。这是我之前展示给你看的XML的第一行。</p>
<p>编号3:这部分的代码输出的最开始的两个标签：我们的根标签，&lt;data&gt;和我们用来放置所有宠物的&lt;pets&gt;标签。</p>
<p>编号4:这部分的代码最困难的。这里包含了一个循环用来遍历你数据库里所有的数据。每次循环，它会输出一个新的节点，这个节点用每一种动物作为标签名以及一个"任务"属性。例如，如果你数据库中的第一只宠物是“猫”而且它相应的任务字段是“喂食, 饮水, 抓跳蚤”，那php将输出在XML文档中输出 &lt;猫 tasks="喂食, 饮水, 抓跳蚤" /&gt; 。这个“\n” 部分只是在结尾插入一个新行，保证这个XML代码不至于都在同一行。</p>
<p>编号5:这部分的代码结束了 我们开始时打开的&lt;/pets&gt; 和 &lt;/data&gt; 节点。因为XML必须是格式良好的（well-formed），所以我们必须认真对待这部分以确认我们的程序能够正确运行。</p>
<p>现在我们已经让PHP输出XML了，我们现在所要作的就是登录我们的mysql数据库，并进行我们所需要的修改，来更新这个XML。很酷，不是吗？我们仍然能够使用上一篇文章中的js脚本来获取代码，因为XML输出和之前的完全一样。</p>
<p><strong>结论</strong></p>
<p>你可以再进一步的扩展，使用XML来保存和获取数据。换句话说，你能够使用php来写你的XML文件，然后让javascript来读。用ajax，你也能够定时的检查xml文件是否已经更改而且，如果XML已经更新，也可以更新本页面。</p>
<p><strong>关于作者</strong></p>
<p>Jonathan Fenocchi(mail:jona#slightlyremarkable.com #换成@)是一个网络开发者，主攻web设计，客户端脚本，php脚本。<br />他的网站位于：<u>http://www.slightlyremarkable.com</u></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-16 16:14:53</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%87%e4%bb%b6/" title="文件">文件</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae/" title="数据">数据</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/xml/" title="xml">xml</a>, <a href="https://www.iamivan.net/tag/%e8%8a%82%e7%82%b9/" title="节点">节点</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>如何使用ajax开发web应用程序的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2pL8qRp.html" rel="bookmark">如何使用Ajax开发Web应用程序&lpar;1&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ajax|web|程序 作者: Jonathan Fenocchi 时间:2005.10.25 译者:Sheneyan 英文原文:http://webreference.com/programming/javascript/jf/column12/index.html 在过去,由于为了获得新数据而不得不重新加载web页面(或者加载其他页面)导致web应用程序发展被限制.虽然有其他方法可用(不加载其他页面),但是这些技术都没有被很好地支持而且有bug成灾的趋向.在过去的几个月里,一个过去并不被广泛			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boLKegM.html" rel="bookmark">如何使用ajax开发web应用程序第1&sol;2页&lowbar;AJAX相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者: Jonathan Fenocchi时间:2005.10.25译者:Sheneyan英文原文:http://webreference.com/programming/javascript/jf/column12/index.html 在过去,由于为了获得新数据而不得不重新加载web页面(或者加载其他页面)导致web应用程序发展被限制.虽然有其他方法可用(不加载其他页面),但是这些技术都没有被很好地支持而且有bug成灾的趋向.在过去的几个月里,一个过去并不被广泛支持的技术已经被越来越多的we			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX2Bxlb.html" rel="bookmark">如何使用ajax开发web应用程序第1&sol;2页</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者: Jonathan Fenocchi时间:2005.10.25译者:Sheneyan英文原文:http://webreference.com/programming/javascript/jf/column12/index.html 在过去,由于为了获得新数据而不得不重新加载web页面(或者加载其他页面)导致web应用程序发展被限制.虽然有其他方法可用(不加载其他页面),但是这些技术都没有被很好地支持而且有bug成灾的趋向.在过去的几个月里,一个过去并不被广泛支持的技术已经被越来越多的we			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/rz43n8p.html" rel="bookmark">如何使用Ajax技术开发Web应用程序&lpar;3&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ajax|web|程序 在这个关于AJAX系列的第三部分中(相关文章:第一部分.第二部分),我们将学习如何使用AJAX与服务端进行写作以及这些技术如何产生强大的web应用程序.如果你对学习如何构建类似GMail或者Google Maps的web程序感兴趣的话,这是一篇基础的入门(虽然那两个东东会比我们在这篇文章中提及的内容复杂的多).在这篇文章中,我使用PHP作为服务端语言,但AJAX能够和任何服务端语言进行很好的兼容,所以你尽可以选择你所钟爱的任何语言! 我们还是从我们上一篇文章的代码(喏,就			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zOky3z.html" rel="bookmark">如何使用Ajax技术开发Web应用程序&lpar;2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ajax|web|程序 在上一篇文章中,我们讨论了如何通过javascript从一个远程XML文件中取得数据.在这篇文章中,我们将学会怎样对数据作更复杂的处理.作为一个示例,我们会准备一组XML数据,将数据分割成独立的片断并以不同的方式展示这些片断(取决于它们是如何被标识的). 这篇文章是建立在上一篇文章中构造的示例代码的基础之上,所以如果你不能理解我们现在的代码,你可以回过头去读第一篇文章(sheneyan注:就在上面). 开始- 让我们开始我们的第一步:构造XML.我们准备写一个XML文档,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/6b3E3Np.html" rel="bookmark">如何使用Ajax技术开发Web应用程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ajax|web|程序 在上一篇文章中,我们讨论了如何通过javascript从一个远程XML文件中取得数据.在这篇文章中,我们将学会怎样对数据作更复杂的处理.作为一个示例,我们会准备一组XML数据,将数据分割成独立的片断并以不同的方式展示这些片断(取决于它们是如何被标识的). 这篇文章是建立在上一篇文章中构造的示例代码的基础之上,所以如果你不能理解我们现在的代码,你可以回过头去读第一篇文章(sheneyan注:就在上面). 开始- 让我们开始我们的第一步:构造XML.我们准备写一个XML文档,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/gpkkqrp.html" rel="bookmark">如何使用Ajax技术开发Web应用程序&lpar;1&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在过去,由于为了获得新数据而不得不重新加载web页面(或者加载其他页面)导致web应用程序发展被限制.虽然有其他方法可用(不加载其他页面),但是这些技术都没有被很好地支持而且有bug成灾的趋向.在过去的几个月里,一个过去并不被广泛支持的技术已经被越来越多的web冲浪者(web surfers??是指浏览器还是浏览者?)所接受,它给了开发者更多的自由开发先进的web应用程序.这些通过javascript来异步取得xml数据的应用程序,被亲切的称为&quot;Ajax应用程序&quot;(Asynchrono			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY2knrp.html" rel="bookmark">如何使用Ajax技术开发Web应用程序（2）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇文章中,我们讨论了如何通过javascript从一个远程XML文件中取得数据.在这篇文章中,我们将学会怎样对数据作更复杂的处理.作为一个示例,我们会准备一组XML数据,将数据分割成独立的片断并以不同的方式展示这些片断(取决于它们是如何被标识的). 这篇文章是建立在上一篇文章中构造的示例代码的基础之上,所以如果你不能理解我们现在的代码,你可以回过头去读第一篇文章(sheneyan注:就在上面). 开始- 让我们开始我们的第一步:构造XML.我们准备写一个XML文档,它组织了一系列准备让ja			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK7Lw7b.html" rel="bookmark">如何使用Ajax技术开发Web应用程序（1）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在过去,由于为了获得新数据而不得不重新加载web页面(或者加载其他页面)导致web应用程序发展被限制.虽然有其他方法可用(不加载其他页面),但是这些技术都没有被很好地支持而且有bug成灾的趋向.在过去的几个月里,一个过去并不被广泛支持的技术已经被越来越多的web冲浪者(web surfers??是指浏览器还是浏览者?)所接受,它给了开发者更多的自由开发先进的web应用程序.这些通过javascript来异步取得xml数据的应用程序,被亲切的称为&quot;Ajax应用程序&quot;(Asynchrono			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlmkYp.html" rel="bookmark" class="title">ios-问题：UIView的位置检测</a>
					<div>
						问题描述 问题:UIView的位置检测 请问,怎么样检测UIView的框架和我的框架是否匹配? 我用的方法: CGRect myFrame;myFrame = CGRectMake(0 -51 320 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyJX4p.html" rel="bookmark" class="title">京东商城刘强东&colon;京东是用互联网卖东西的公司</a>
					<div>
						关于2010年的中国互联网,很多悲观的业内人士认为只剩下电子商务了:关于2010年的中国互联网,很多乐观的业内人士认为,电子商务会在这一年腾飞:关于2010年的中国互联网,中国足球中超联赛的球迷知道, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQJNQM.html" rel="bookmark" class="title">用FrontPage 2003发布您的网站</a>
					<div>
						frontpage 远程网站视图 Microsoft office FrontPage 2003 中的远程网站视图可以帮助您将整个网站和单独的文件和文件夹发布到任何位置:扩展的 Web 服务器.支持文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPLmPM.html" rel="bookmark" class="title">WPS表格教程：SUMPRODUCT函数应用两则</a>
					<div>
						SUMPRODUCT函数的作用是在给定的几组数组中,将数组间对应的元素相乘,并返回乘积之和.其语法格式为SUMPRODUCT(数据1,数据2,--,数据30),比如公式&quot;=SUMPRODUC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBnY5b.html" rel="bookmark" class="title">rpc服务器不可用</a>
					<div>
						很多朋友在给自己的打印机安装驱动程序的时候会遇到提示&quot;无法安装这个硬件,RPC服务器不可用&quot;的情况,那么什么是PRC,为什么会提示rpc服务器不可用呢?小编搜集整理如下: 在执行下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKekdM.html" rel="bookmark" class="title">udp-QQ通讯使用UDP&comma; 那它怎么实现发送消息失败提醒的</a>
					<div>
						问题描述 QQ通讯使用UDP, 那它怎么实现发送消息失败提醒的 既然是点对点的通信,就不用经过腾讯服务器啊,那它怎么检测到的? 还有,我的qq怎么知道对方qq的IP和应用端口号的? 求解啊!有没有大神 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WqA8b.html" rel="bookmark" class="title">spring数据源-关于spring AbstractRoutingDataSource和切面执行顺序问题</a>
					<div>
						问题描述 关于spring AbstractRoutingDataSource和切面执行顺序问题 我想spring AbstractRoutingDataSource和spring aop配合使用,达 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NyK6z.html" rel="bookmark" class="title">芯片巨头三国杀：AI加剧芯片厂商间竞赛，英特尔、英伟达、AMD竞相发力</a>
					<div>
						随着智能手机和个人电脑销售数量减少,芯片厂商正在竞相开发人工智能产品,以推动业绩增长. 英伟达.英特尔.AMD和一大批初创公司正在研发新的处理器,以开拓人工智能软硬件市场.据IDC公司调查,AI软硬件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamG8Xb.html" rel="bookmark" class="title">数据库表结构设计方面</a>
					<div>
						问题描述 数据库表结构设计方面 为什么现在很多人设计表结构时都不设置外键关联,全部都是单表,这样设计有什么好处吗?缺点又有哪些? 解决方案 优点很多,比如说使用伪删除代替删除(也就是用一个字段标记代替 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4DVLz.html" rel="bookmark" class="title">在eclipse安装windowbuilder插件</a>
					<div>
						在线安装windowbuilder插件 1.查看所安装的eclipse的版本号(我安装的是Neon版) 2.打开http://www.eclipse.org/windowbuilder/downloa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4aGZz.html" rel="bookmark" class="title">关于友情链接推广经验的几点总结</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 近半个月主要做的是友情链接推广,看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JlRkz.html" rel="bookmark" class="title">多线程复用以下延时过程，会排队吗？时序会乱吗？会线程不安全吗？</a>
					<div>
						问题描述 privatevoidDelay(intt){System.Diagnostics.Stopwatchsw=newSystem.Diagnostics.Stopwatch();sw.Rest ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RElRz.html" rel="bookmark" class="title">spark-关于Spark on Yarn运行WordCount的问题</a>
					<div>
						问题描述 关于Spark on Yarn运行WordCount的问题 运行wordcount程序是,一直提示以下的内容,yarnAppState状态一直没有变成running: 14/05/13 15 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgn0WM.html" rel="bookmark" class="title">数据库中的事务、存储过程和触发器的简单使用</a>
					<div>
						什么是事务(Transaction) 指访问并可能更新数据库中各种数据项的一个程序执行单元(unit)--也就是由多个sql语句组成,必须作为一个整体执行 这些sql语句作为一个整体一起向系统提交,要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgw2GEM.html" rel="bookmark" class="title">Zynga宁可关闭OMGPOP也不卖给其创始人</a>
					<div>
						[导读]OMGPOP是流行画画猜词游戏&lt;你画我猜&gt;的开发商,此外还拥有其他35款社交游戏.OMGPOP创始人查尔斯·福尔曼( 腾讯科技配图)腾讯科技讯(明轩)北京时间8月8日消息,据国外媒 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2dP4z.html" rel="bookmark" class="title">互联网产品如何从无到有聚集用户？</a>
					<div>
						作者:@李意娟 最近遇到考题:一个互联网产品如何从无到有聚集用户?对此,我分了3个阶段来进行论述.(中间加了一些孙子兵法的观点,学习孙子兵法,对做产品也有一定的指导思想.希望更多的人能学习国学,爱国学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6G03gp.html" rel="bookmark" class="title">Android基础之使用Fragment控制切换多个页面&lowbar;Android</a>
					<div>
						今天讲解一下Fragment的控制,主要是切换View和页面替换等操作.还有就是如何获取Fragment的管理对象,以及与Activity的通信方式.1.管理Fragment要在activity中管理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlma38p.html" rel="bookmark" class="title">《Android游戏开发详解》&mdash;&mdash;第1章，第1&period;9节训练到此结束</a>
					<div>
						1.9 训练到此结束Android游戏开发详解如果你已经学到了这里,恭喜你!你已经完成了进入美丽的.复杂的并且偶尔令人沮丧的编程世界的第一步.但是,在编写一些Java代码之前,你还不能自称为一名Jav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ10v0b.html" rel="bookmark" class="title">gdi使用经验分享</a>
					<div>
						在windows系列上做编程,gdi是一个很重要的技术点,有很多程序在运行多次后出现异常,除了众所周知的内存泄露以外,gdi资源泄露也是一个很直接的原因.今天就把我自己在编程中总结的一些经验给大家分享 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEJ8JqM.html" rel="bookmark" class="title">戴尔营销模式&OpenCurlyDoubleQuote;按订单生产&rdquo;或出现危机</a>
					<div>
						网易科技讯 8月24日消息,据&lt;华尔街日报&gt;报道,戴尔创始人兼CEO迈克尔·戴尔(Michael Dell)采用独特的方式开创了他的事业.相对他的竞争对手而言,这种独特的方式也给予了他一种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRdKYxz.html" rel="bookmark" class="title">销售商揭人造海参黑幕含胶类色素成分还会褪色</a>
					<div>
						海藻粉加胶类物质制成 建议消费者最好不要食用 有着海参的体形和颜色,却没有海参的嘴巴和内脏,就是这些&quot;海参&quot;让张女士和同事付出了一万多元的代价,上门推销的 卖家也从此不再露面.昨日 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0YmXAp.html" rel="bookmark" class="title">SQL Server 2008空间数据应用系列八：基于Bing Maps&lpar;Silverlight&rpar;的空间数据存储</a>
					<div>
						原文:SQL Server 2008空间数据应用系列八:基于Bing Maps(Silverlight)的空间数据存储 友情提示,您阅读本篇博文的先决条件如下: 1.本文示例基于Microsoft S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOWqW3z.html" rel="bookmark" class="title">Linux IO模型漫谈（5）- IO复用模型之select</a>
					<div>
						首先需要了解的是select函数: select函数 #include&lt;sys/select.h&gt; #include&lt;sys/time.h&gt; int select (int m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWyDDM.html" rel="bookmark" class="title">阿里巴巴与创维在智能电视合作上&OpenCurlyDoubleQuote;握手言和&rdquo;</a>
					<div>
						摘要: 从5月至今,已有乐视.爱奇艺.小米等互联网厂商推出智能电视产品,且价格为传统电视厂商同规格产品的一半左右. 阿里巴巴与创维在智能电视合作上握手言和.记者昨日获悉,今 从5月至今,已有乐视.爱奇 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YKAqp.html" rel="bookmark" class="title">导航版 有完整的 交通规则 道路宽度 限速 红绿灯 交通限行 等导航信息 可以做路径规划导航 带道路通行方向</a>
					<div>
						问题描述 导航版有完整的交通规则道路宽度限速红绿灯交通限行等导航信息可以做路径规划导航带道路通行方向 解决方案 本帖最后由 QQ369045130 于 2011-09-27 14:57:30 编辑解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLB9rAb.html" rel="bookmark" class="title">两家知名社交网站倒闭后 SNS网站如何笑到最后</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 7月1日,一向风光无限的国内知名SNS网站360圈宣布倒闭,近日,又一家SNS网站蚂蚁网发布公告:将于7月30日关站.原因是公司现金流已断裂,无法继续运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEQn19b.html" rel="bookmark" class="title">集合的问题</a>
					<div>
						问题描述 package cn.com.liheng.Test;import java.util.ArrayList;import java.util.List;import cn.com.lihen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z43LYYp.html" rel="bookmark" class="title">组建小型局域网100台计算机和几台服务器</a>
					<div>
						问题描述 页数大于10页不超过20页内容包括:安装文档配置信息帐户改建服务器错误及纠正措施病毒的侵犯和安全配置紧跟最新备份和灾难恢复工具使用硬件故障和/或重新配置 解决方案 解决方案二: 解决方案三: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvqX76b.html" rel="bookmark" class="title">JavaScript教程：JavaScript如何判定用户浏览器类型和版本号？</a>
					<div>
						function userAgent(){   var ua = navigator.userAgent;   ua = ua.toLowerCase();  var match = /(webkit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boOWqdb.html" rel="bookmark" class="title">CentOS网络接口配置文件ifcfg-eth0详解</a>
					<div>
						==CentOS网络接口配置文件ifcfg-eth0详解== 文件 /etc/sysconfig/network-scripts/ifcfg-eth0在/etc/sysconfig/network-s ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.045 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
